[![Python](https://img.shields.io/badge/made%20with-python-blue.svg?)](https://www.python.org)
[![GitHub stars](https://img.shields.io/github/stars/dipdup-net/dipdup)](https://github.com/dipdup-net/dipdup)
[![Latest stable release](https://img.shields.io/github/v/release/dipdup-net/dipdup?label=stable)](https://github.com/dipdup-net/dipdup/releases)
[![Latest pre-release)](https://img.shields.io/github/v/release/dipdup-net/dipdup?include_prereleases&label=latest)](https://github.com/dipdup-net/dipdup/releases)
[![PyPI monthly downloads](https://img.shields.io/pypi/dm/dipdup)](https://pypi.org/project/dipdup/)
<br>
[![GitHub tests](https://img.shields.io/github/workflow/status/dipdup-net/dipdup/Test)](https://github.com/dipdup-net/dipdup/actions)
[![GitHub issues](https://img.shields.io/github/issues/dipdup-net/dipdup)](https://github.com/dipdup-net/dipdup/issues)
[![GitHub pull requests](https://img.shields.io/github/issues-pr/dipdup-net/dipdup)](https://github.com/dipdup-net/dipdup/pulls)
[![License: MIT](https://img.shields.io/github/license/dipdup-net/dipdup)](https://github.com/dipdup-net/dipdup/blob/master/LICENSE)

```text
        ____   _         ____              
       / __ \ (_)____   / __ \ __  __ ____ 
      / / / // // __ \ / / / // / / // __ \
     / /_/ // // /_/ // /_/ // /_/ // /_/ /
    /_____//_// .___//_____/ \__,_// .___/ 
             /_/                  /_/      
```

DipDup is a Python framework for building indexers of [Tezos](https://tezos.com/) smart contracts. It helps developers focus on the business logic instead of writing data storing and serving boilerplate. DipDup-based indexers are selective, which means only required data is requested. This approach allows to achieve faster indexing times and decreased load on APIs DipDup uses.

* **Ready to build your first indexer?** Head to [Quickstart](https://docs.dipdup.io/quickstart).

* **Looking for examples?** Check out [Demo Projects](https://github.com/dipdup-net/dipdup/tree/master/src).

* **Want to contribute?** See [Contribution Guide](https://github.com/dipdup-net/dipdup/tree/master/CONTRIBUTING.md).

* **Have a question?** Contact us on [Discord](https://discord.com/invite/RcPGSdcVSx), [Telegram](https://t.me/baking_bad_chat), or [Slack](https://tezos-dev.slack.com/archives/CV5NX7F2L)!

This project is maintained by the [Baking Bad](https://baking-bad.org/) team.
<br>
Development is supported by [Tezos Foundation](https://tezos.foundation/).
